Loading...
Searching...
No Matches
gtsam::BearingFactor< A1, A2, T > Struct Template Reference
SAM

## Detailed Description

template<typename A1, typename A2, typename T = typename Bearing<A1, A2>::result_type>
struct gtsam::BearingFactor< A1, A2, T >

Binary factor for a bearing measurement Works for any two types A1,A2 for which the functor Bearing<A1,A2>() is defined.

Inheritance diagram for gtsam::BearingFactor< A1, A2, T >:

## Public Member Functions

| BearingFactor ()
| default constructor
| BearingFactor (Key key1, Key key2, const T &measured, const SharedNoiseModel &model)
| primary constructor
Expression< T > | expression (const typename Base::ArrayNKeys &keys) const override
void | print (const std::string &s="", const KeyFormatter &kf=DefaultKeyFormatter) const override
| print
Vector | evaluateError (const A1 &a1, const A2 &a2, boost::optional< Matrix & > H1=boost::none, boost::optional< Matrix & > H2=boost::none) const
Public Member Functions inherited from gtsam::ExpressionFactorN< T, Args >
| ~ExpressionFactorN () override=default
| Destructor.
virtual Expression< T > | expression (const ArrayNKeys &keys) const
| Recreate expression from given keys_ and measured_, used in load Needed to deserialize a derived factor.
Public Member Functions inherited from gtsam::ExpressionFactor< T >
| ExpressionFactor (const SharedNoiseModel &noiseModel, const T &measurement, const Expression< T > &expression)
| Constructor: creates a factor from a measurement and measurement function.
| ~ExpressionFactor () override
| Destructor.
const T & | measured () const
| return the measurement
void | print (const std::string &s="", const KeyFormatter &keyFormatter=DefaultKeyFormatter) const override
| print relies on Testable traits being defined for T
bool | equals (const NonlinearFactor &f, double tol) const override
| equals relies on Testable traits being defined for T
Vector | unwhitenedError (const Values &x, boost::optional< std::vector< Matrix > & > H=boost::none) const override
| Error function without the NoiseModel, \( z-h(x) -> Local(h(x),z) \).
boost::shared_ptr< GaussianFactor > | linearize (const Values &x) const override
| linearize to a GaussianFactor
gtsam::NonlinearFactor::shared_ptr | clone () const override
Public Member Functions inherited from gtsam::NoiseModelFactor
| NoiseModelFactor ()
| Default constructor for I/O only.
| ~NoiseModelFactor () override
| Destructor.
template<typename CONTAINER>
| NoiseModelFactor (const SharedNoiseModel &noiseModel, const CONTAINER &keys)
| Constructor.
void | print (const std::string &s="", const KeyFormatter &keyFormatter=DefaultKeyFormatter) const override
| Print.
bool | equals (const NonlinearFactor &f, double tol=1e-9) const override
| Check if two factors are equal.
size_t | dim () const override
| get the dimension of the factor (number of rows on linearization)
const SharedNoiseModel & | noiseModel () const
| access to the noise model
Vector | whitenedError (const Values &c) const
| Vector of errors, whitened This is the raw error, i.e., i.e.
Vector | unweightedWhitenedError (const Values &c) const
| Vector of errors, whitened, but unweighted by any loss function.
double | weight (const Values &c) const
| Compute the effective weight of the factor from the noise model.
double | error (const Values &c) const override
| Calculate the error of the factor.
boost::shared_ptr< GaussianFactor > | linearize (const Values &x) const override
| Linearize a non-linearFactorN to get a GaussianFactor, \( Ax-b \approx h(x+\delta x)-z = h(x) + A \delta x - z \) Hence \( b = z - h(x) = - \mathtt{error\_vector}(x) \).
shared_ptr | cloneWithNewNoiseModel (const SharedNoiseModel newNoise) const
| Creates a shared_ptr clone of the factor with a new noise model.
| NonlinearFactor ()
| Default constructor for I/O only.
template<typename CONTAINER>
| NonlinearFactor (const CONTAINER &keys)
| Constructor from a collection of the keys involved in this factor.
void | print (const std::string &s="", const KeyFormatter &keyFormatter=DefaultKeyFormatter) const override
| print
virtual | ~NonlinearFactor ()
| Destructor.
double | error (const HybridValues &c) const override
| All factor types need to implement an error function.
virtual bool | active (const Values &) const
| Checks whether a factor should be used based on a set of values.
virtual shared_ptr | rekey (const std::map< Key, Key > &rekey_mapping) const
| Creates a shared_ptr clone of the factor with different keys using a map from old->new keys.
virtual shared_ptr | rekey (const KeyVector &new_keys) const
| Clones a factor and fully replaces its keys.
virtual bool | sendable () const
| Should the factor be evaluated in the same thread as the caller This is to enable factors that has shared states (like the Python GIL lock).
Public Member Functions inherited from gtsam::Factor
virtual | ~Factor ()=default
| Default destructor.
bool | empty () const
| Whether the factor is empty (involves zero variables).
Key | front () const
| First key.
Key | back () const
| Last key.
const_iterator | find (Key key) const
| find
const KeyVector & | keys () const
| Access the factor's involved variable keys.
const_iterator | begin () const
| Iterator at beginning of involved variable keys.
const_iterator | end () const
| Iterator at end of involved variable keys.
size_t | size () const
virtual void | printKeys (const std::string &s="Factor", const KeyFormatter &formatter=DefaultKeyFormatter) const
| print only keys
bool | equals (const This &other, double tol=1e-9) const
| check equality
KeyVector & | keys ()
iterator | begin ()
| Iterator at beginning of involved variable keys.
iterator | end ()
| Iterator at end of involved variable keys.

## Public Types

typedef ExpressionFactorN< T, A1, A2 > | Base
Public Types inherited from gtsam::ExpressionFactorN< T, Args >
using | ArrayNKeys = std::array<Key, NARY_EXPRESSION_SIZE>
Public Types inherited from gtsam::ExpressionFactor< T >
typedef boost::shared_ptr< ExpressionFactor< T > > | shared_ptr
Public Types inherited from gtsam::NoiseModelFactor
typedef boost::shared_ptr< This > | shared_ptr
| Noise model.
Public Types inherited from gtsam::NonlinearFactor
typedef boost::shared_ptr< This > | shared_ptr
Public Types inherited from gtsam::Factor
typedef KeyVector::iterator | iterator
| Iterator over keys.
typedef KeyVector::const_iterator | const_iterator
| Const iterator over keys.

## Friends

class | boost::serialization::access

## Additional Inherited Members

Static Public Attributes inherited from gtsam::ExpressionFactorN< T, Args >
static const std::size_t | NARY_EXPRESSION_SIZE = sizeof...(Args)
Protected Types inherited from gtsam::ExpressionFactor< T >
typedef ExpressionFactor< T > | This
Protected Types inherited from gtsam::NoiseModelFactor
typedef NonlinearFactor | Base
typedef NoiseModelFactor | This
Protected Types inherited from gtsam::NonlinearFactor
typedef Factor | Base
typedef NonlinearFactor | This
Protected Member Functions inherited from gtsam::ExpressionFactorN< T, Args >
| ExpressionFactorN ()=default
| Default constructor, for serialization.
| ExpressionFactorN (const ArrayNKeys &keys, const SharedNoiseModel &noiseModel, const T &measurement)
| Constructor takes care of keys, but still need to call initialize.
Protected Member Functions inherited from gtsam::ExpressionFactor< T >
| ExpressionFactor (const SharedNoiseModel &noiseModel, const T &measurement)
| Default constructor, for serialization.
void | initialize (const Expression< T > &expression)
| Initialize with constructor arguments.
Protected Member Functions inherited from gtsam::NoiseModelFactor
| NoiseModelFactor (const SharedNoiseModel &noiseModel)
| Constructor - only for subclasses, as this does not set keys.
| Factor ()
| Default constructor for I/O.
template<typename CONTAINER>
| Factor (const CONTAINER &keys)
| Construct factor from container of keys.
template<typename ITERATOR>
| Factor (ITERATOR first, ITERATOR last)
| Construct factor from iterator keys.
template<typename CONTAINER>
static Factor | FromKeys (const CONTAINER &keys)
| Construct factor from container of keys.
template<typename ITERATOR>
static Factor | FromIterators (ITERATOR first, ITERATOR last)
| Construct factor from iterator keys.
Protected Attributes inherited from gtsam::ExpressionFactor< T >
T | measured_
| the measurement to be compared with the expression
Expression< T > | expression_
| the expression that is AD enabled
FastVector< int > | dims_
| dimensions of the Jacobian matrices
Protected Attributes inherited from gtsam::NoiseModelFactor
SharedNoiseModel | noiseModel_
Protected Attributes inherited from gtsam::Factor
KeyVector | keys_
| The keys involved in this factor.
Static Protected Attributes inherited from gtsam::ExpressionFactor< T >
static const int | Dim = traits<T>::dimension

## Member Function Documentation

## print()

template<typename A1, typename A2, typename T = typename Bearing<A1, A2>::result_type>

void gtsam::BearingFactor< A1, A2, T >::print | ( | const std::string & | s = "",
|  | const KeyFormatter & | kf = DefaultKeyFormatter ) const

inline override virtual

print

Reimplemented from gtsam::Factor.

The documentation for this struct was generated from the following file:

- /build/gtsam-Xg031d/gtsam-4.2.0+dfsg/gtsam/sam/BearingFactor.h